searchData={"items":[{"type":"module","title":"MDExMermaid","doc":"[MDEx](https://mdelixir.dev) plugin for [Mermaid](https://mermaid.js.org).","ref":"MDExMermaid.html"},{"type":"module","title":"Usage - MDExMermaid","doc":"````elixir\nMix.install([\n  {:mdex_mermaid, \"~> 0.1\"}\n])\n\nmarkdown = \"\"\"\n# Flowchart\n\n```mermaid\ngraph TD;\n    A-->B;\n    A-->C;\n    B-->D;\n    C-->D;\n```\n\"\"\"\n\nmdex = MDEx.new() |> MDExMermaid.attach()\n\nMDEx.to_html!(mdex, document: markdown) |> IO.puts()\n#=>\n#  \n#   import mermaid from 'https://cdn.jsdelivr.net/npm/mermaid@11/dist/mermaid.esm.min.mjs';\n#   const theme = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'default';\n#   mermaid.initialize({securityLevel: 'loose', theme: theme});\n#  \n#  Flowchart \n#  graph TD;\n#     A-->B;\n#     A-->C;\n#     B-->D;\n#     C-->D;\n#  \n````\n\nSee [attach/2](https://hexdocs.pm/mdex_mermaid/MDExMermaid.html#attach/2) for more info.","ref":"MDExMermaid.html#module-usage"},{"type":"function","title":"MDExMermaid.attach/2","doc":"Attaches the MDExMermaid plugin into the MDEx pipeline.\n\n- Mermaid is loaded from https://www.jsdelivr.com/package/npm/mermaid\n- Theme is determined by the user's `prefers-color-scheme` system preference","ref":"MDExMermaid.html#attach/2"},{"type":"function","title":"Options - MDExMermaid.attach/2","doc":"- `:mermaid_pre_attrs` (`t:mermaid_pre_attrs/0`) - Function that generates the ` ` tag attributes for mermaid code blocks.\n  - `:mermaid_init` (`t:String.t/0`) - The HTML tag(s) to inject into the document to initialize mermaid. If `nil`, the default script is used (see below).\n\n### :mermaid_pre_attrs\n\nWhenever a code block tagged as `mermaid` is found, it gets converted into a ` ` tag using the following function to generate its attributes:\n\n\n    pre_attrs = fn seq -> ~s(id=\"mermaid-#{seq}\" class=\"mermaid\" phx-update=\"ignore\") end\n    mdex = MDEx.new() |> MDExMermaid.attach(mermaid_pre_attrs: pre_attrs)\n\nWhich results in:\n\n     \n      flowchart LR\n        ...\n     \n\nYou can override it to include or manipulate the attributes but it's important to maintain unique IDs for each instance,\notherwise the mermaid rendering will not work correctly, for eg:\n\n    fn seq -> ~s(id=\"mermaid-#{seq}\" class=\"mermaid graph\" phx-hook=\"MermaidHook\" phx-update=\"ignore\") end\n\n### :mermaid_init\n\nThe option `:mermaid_init` can be used to manipulate how mermaid is initialized. By default, the following script is injected into the top of the document:\n\n```html\n \n  import mermaid from \"https://cdn.jsdelivr.net/npm/mermaid@11/dist/mermaid.esm.min.mjs\";\n  const theme = window.matchMedia && window.matchMedia(\"(prefers-color-scheme: dark)\").matches ? \"dark\" : \"default\";\n  mermaid.initialize({securityLevel: \"loose\", theme: theme});\n \n```\n\nThat script works well on static documents but you'll need to adjust it to initialize mermaid in environments\nthat requires waiting for the DOM to be ready.","ref":"MDExMermaid.html#attach/2-options"},{"type":"function","title":"Examples - MDExMermaid.attach/2","doc":"","ref":"MDExMermaid.html#attach/2-examples"},{"type":"function","title":"DOMContentLoaded - MDExMermaid.attach/2","doc":"@mermaid_init \"\"\"\n      \n     \n      document.addEventListener(\"DOMContentLoaded\", () => {\n        const theme = window.matchMedia && window.matchMedia(\"(prefers-color-scheme: dark)\").matches ? \"dark\" : \"default\";\n        mermaid.initialize({securityLevel: \"loose\", theme: theme});\n     \n    \"\"\"\n\n    mdex = MDEx.new() |> MDExMermaid.attach(mermaid_init: @mermaid_init)","ref":"MDExMermaid.html#attach/2-domcontentloaded"},{"type":"function","title":"Phoenix LiveView - MDExMermaid.attach/2","doc":"To use MDExMermaid with Phoenix LiveView, you can:\n\n1. Load Mermaid (via CDN or npm)\n2. Create a LiveView hook to render diagrams\n3. Configure MDExMermaid with the appropriate attributes","ref":"MDExMermaid.html#attach/2-phoenix-liveview"},{"type":"function","title":"Option 1: Using CDN - MDExMermaid.attach/2","doc":"In your layout:\n\n```html\n \n  import mermaid from 'https://cdn.jsdelivr.net/npm/mermaid@11/dist/mermaid.esm.min.mjs';\n  const theme = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'default';\n  mermaid.initialize({ startOnLoad: false, securityLevel: 'loose', theme: theme });\n  window.mermaid = mermaid;\n \n```","ref":"MDExMermaid.html#attach/2-option-1-using-cdn"},{"type":"function","title":"Option 2: Using npm - MDExMermaid.attach/2","doc":"Install Mermaid as a dependency:\n\n```bash\ncd assets && npm install mermaid\n```\n\nIn your `assets/js/app.js`:\n\n```javascript\nimport mermaid from 'mermaid'\n\nconst theme = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'default';\n\nmermaid.initialize({ \n  startOnLoad: false, \n  securityLevel: 'loose',\n  theme: theme,\n})\n\nlet hooks = {\n  MermaidHook: {\n    mounted() {\n      mermaid.run({\n        querySelector: '.mermaid'\n      });\n    }\n  }\n}\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {params: {_csrf_token: csrfToken}, hooks: hooks})\n```","ref":"MDExMermaid.html#attach/2-option-2-using-npm"},{"type":"function","title":"Using in LiveView - MDExMermaid.attach/2","doc":"```elixir\nhtml =\n  MDEx.new()\n  |> MDExMermaid.attach(\n    mermaid_init: \"\", # already initialized\n    mermaid_pre_attrs: fn seq ->\n      ~s(id=\"mermaid-#{seq}\" class=\"mermaid\" phx-hook=\"MermaidHook\" phx-update=\"ignore\")\n    end\n  )\n  |> MDEx.to_html!(document: markdown)\n\nassign(socket, html: {:safe, html})}\n```\n\nNote that you can attach a JS hook per diagram or in a parent element to handle all diagrams at once, depending on your needs.\n\nSee this [LiveView example](https://github.com/leandrocp/mdex_mermaid/blob/main/examples/live_view.exs)","ref":"MDExMermaid.html#attach/2-using-in-liveview"},{"type":"type","title":"MDExMermaid.mermaid_pre_attrs/0","doc":"","ref":"MDExMermaid.html#t:mermaid_pre_attrs/0"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.3.0 - 2025-07-07 - Changelog","doc":"","ref":"changelog.html#0-3-0-2025-07-07"},{"type":"extras","title":"Changed - Changelog","doc":"- **Breaking:** Remove option `:mermaid_version` in favor of `:mermaid_init`\n- **Breaking:** Remove option `:mermaid_security_level` in favor of `:mermaid_init`","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Add customizable attributes for mermaid ` ` tags via `:mermaid_pre_attrs` option\n- Add customizable initialization script via `:mermaid_init` option","ref":"changelog.html#added"},{"type":"extras","title":"0.2.0 - 2025-04-08 - Changelog","doc":"","ref":"changelog.html#0-2-0-2025-04-08"},{"type":"extras","title":"Changed - Changelog","doc":"- **Breaking:** Rename option `:version` to `:mermaid_version`\n- **Breaking:** Rename option `:security_level` to `:mermaid_security_level`","ref":"changelog.html#changed-1"},{"type":"extras","title":"Fixed - Changelog","doc":"- Merge all options in `attach/2`","ref":"changelog.html#fixed"},{"type":"extras","title":"0.1.0 - 2025-03-31 - Changelog","doc":"","ref":"changelog.html#0-1-0-2025-03-31"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release","ref":"changelog.html#added-1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}